// Memory ops
int loadi( int base, int offset = 0 );
float loadf( int base, int offset = 0 );
void storei( int value, int base, int offset = 0 );
void storef( float value, int base, int offset = 0 );

// Arithmetic
int atomicinc( int location);
float min( float left, float right );
float max( float left, float right );
float invsqrt( float value );

// Debug
void profile( int prof_id );
int loadl1( int base, int offset = 0 );
void trax_printi(int value);
void trax_printf( float value );

void trax_setup();
void trax_cleanup();


// playing with threads (should just call callback function for trax version?)
// returns success of the operation (if false, user should call render function directly)
bool trax_start_render_threads( void* (*renderFunc)(void*), const int &numThreads=1 );
